<template>
  <div class="app-container">
    <el-card class="box-card app-container">
      <el-row slot="header">
        <el-col :span="20">
          <h3>{{ title }}</h3>
        </el-col>
        <el-col :span="4">
          <el-button type="primary" class="fr" @click="submit">
            Guardar
          </el-button>
        </el-col>
      </el-row>
      <el-form class="form" ref="fields" :rules="rules" :model="fields" label-position="top">
        <el-row :gutter="20">
          <el-col :span="20">
            <el-form-item label="E-mail" prop="email" :error="errors.email">
              <el-input type="email" v-model.trim="fields.email" placeholder="sampleuser@provider.com" />
            </el-form-item>
          </el-col>
          <el-col :span="4">
            <el-form-item label="Imágen Perfil">
              <img v-if="this.fields.avatar" :src="this.fields.avatar" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="Rol" prop="role" :error="errors.role">
              <el-select v-model.trim="fields.role" placeholder="Rol">
                <el-option
                  v-for="(role, idx) in roles"
                  :key="idx"
                  :label="$t(role)"
                  :value="role">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="Contraseña" prop="password" :error="errors.password">
              <el-input type="password" v-model.trim="fields.password" placeholder="Contraseña..." />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-card>
  </div>
</template>

<script>
  import api from '@/feathers'
  import BaseForm from '@/common/base-form.mixin'
  import AppAutocomplete from '@/common/app-autocomplete'
  import auth from '@/services/auth'

  export default {
    name: 'user-form',
    mixins: [BaseForm],
    props: {
      id: {type: String, required: false, default: null}
    },
    components: {
      AppAutocomplete
    },
    computed: {
      title() {
        return `Actualizar ${this.fields.email}`
      }
    },
    data() {
      const rules = {
        email: [
          { required: true, message: 'Debe ingresar un email', trigger: 'blur' },
          { type: 'email', message: 'Debe ingresar un mail válido', trigger: 'bluer' }
        ],
        role: [
          { required: true, message: 'Debe ingresar un rol para el usuario', type: 'string', trigger: 'blur' },
        ],
        password: [
          { required: true, message: 'Debe ingresar un password para el usuario', type: 'string', trigger: 'blur' },
        ]
      }
      const {fields, errors} = this.buildForm(rules)

      return {
        rules,
        errors,
        fields,
        roles: []
      }
    },
    async created() {
      this.service = api.service('users')
      this.getRoles()

      if ( this.id ) {
        this.fields = await this.service.get(this.id)
        this.action = 'update'
      } else {
        this.action = 'create'
      }
    },
    methods: {
      async getRoles() {
        this.roles = auth.getRoles()
      }
    }
  }
</script>

<style lang="scss">
  .el-card {
    &__header {
      margin: 0;
      paddiong: 10px 20px 4px 20px;
      h3 {
        margin: 0;
        padding: 10px 0px;
      }
    }
  }
</style>
